--- cmd_nand_new.c	2006-01-16 17:45:11.000000000 +0800
+++ cmd_nand.c	2005-12-17 00:39:27.000000000 +0800
@@ -196,7 +196,7 @@ int do_nand (cmd_tbl_t *cmdtp, int flag,
 		int ret, total;
 		char* cmdtail = strchr(argv[1], '.');
 
-		if (cmdtail && !strncmp(cmdtail, ".oob", 4)) {
+		if (cmdtail && !strncmp(cmdtail, ".oob", 2)) {
 			/* read out-of-band data */
 			if (cmd & NANDRW_READ) {
 				ret = nand_read_oob(nand_dev_desc + curr_device,
@@ -210,13 +210,13 @@ int do_nand (cmd_tbl_t *cmdtp, int flag,
 			}
 			return ret;
 		}
-		else if (cmdtail && !strncmp(cmdtail, ".jffs2s", 7)) {
+		else if (cmdtail && !strncmp(cmdtail, ".jffs2", 2))
+			cmd |= NANDRW_JFFS2;	/* skip bad blocks */
+		else if (cmdtail && !strncmp(cmdtail, ".jffs2s", 2)) {
 			cmd |= NANDRW_JFFS2;	/* skip bad blocks (on read too) */
 			if (cmd & NANDRW_READ)
 				cmd |= NANDRW_JFFS2_SKIP;	/* skip bad blocks (on read too) */
 		}
-		else if (cmdtail && !strncmp(cmdtail, ".jffs2", 6))
-			cmd |= NANDRW_JFFS2;	/* skip bad blocks */
 #ifdef SXNI855T
 		/* need ".e" same as ".j" for compatibility with older units */
 		else if (cmdtail && !strcmp(cmdtail, ".e"))
